import { float, vec2, vec3, vec4 } from "@thi.ng/shader-ast/ast/lit";
import { clamp } from "@thi.ng/shader-ast/builtin/math";
const __clamp = (min, max) => (x) => x.type === "float"
    ? clamp(x, float(min), float(max))
    : x.type === "vec2"
        ? clamp(x, vec2(min), vec2(max))
        : x.type === "vec3"
            ? clamp(x, vec3(min), vec3(max))
            : clamp(x, vec4(min), vec4(max));
/**
 * Inline function, expands to equivalent of `clamp(x, 0, 1)`.
 *
 * @param x -
 */
export const clamp01 = __clamp(0, 1);
/**
 * Inline function, expands to equivalent of `clamp(x, -1, 1)`.
 *
 * @param x -
 */
export const clamp11 = __clamp(-1, 1);
