import type { Vec2Term } from "@thi.ng/shader-ast";
/**
 * Inline function. Returns counter-clockwise perpendicular vector
 * (assuming Y-up). [-y, x]
 *
 * @param v -
 */
export declare const perpendicularCCW: (v: Vec2Term) => import("@thi.ng/shader-ast").Lit<"vec2">;
/**
 * Inline function. Returns clockwise perpendicular vector (assuming
 * Y-up). [y,-x]
 *
 * @param v -
 */
export declare const perpendicularCW: (v: Vec2Term) => import("@thi.ng/shader-ast").Lit<"vec2">;
/**
 * Returns an orthogonal vector to `v`.
 *
 * {@link http://lolengine.net/blog/2013/09/21/picking-orthogonal-vector-combing-coconuts}
 */
export declare const orthogonal3: import("@thi.ng/shader-ast").TaggedFn1<"vec3", "vec3">;
//# sourceMappingURL=orthogonal.d.ts.map